diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_message.c ircd-hybrid-7-bg/modules/core/m_message.c
--- ircd-hybrid-7rc5/modules/core/m_message.c	Wed Oct 30 12:44:55 2002
+++ ircd-hybrid-7-bg/modules/core/m_message.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_message.c,v 1.104 2002/10/30 17:44:55 wiz Exp $
+ *  $Id: m_message.c,v 1.10 2003/05/25 01:31:33 demond Exp $
  */
 
 #include "stdinc.h"
@@ -34,7 +34,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
-
+#include "fdlist.h"
 #include "channel.h"
 #include "channel_mode.h"
 #include "vchannel.h"
@@ -43,7 +43,8 @@
 #include "class.h"
 #include "msg.h"
 #include "packet.h"
-
+#include "list.h"
+#include "s_misc.h"
 
 struct entity
 {
@@ -97,6 +98,9 @@
                          struct Client *client_p,
                          struct Client *source_p, char *nick, char *text);
 
+static void replace(char *, char *, char *, int);
+static int check_repeat(struct Client *, struct Channel *, char *);
+
 struct Message privmsg_msgtab = {
   "PRIVMSG", 0, 0, 1, 0, MFLG_SLOW | MFLG_UNREG, 0L,
   {m_unregistered, m_privmsg, m_privmsg, m_privmsg}
@@ -123,7 +127,7 @@
   mod_del_cmd(&notice_msgtab);
 }
 
-const char *_version = "$Revision: 1.104 $";
+const char *_version = "$Revision: 1.10 $";
 #endif
 
 /*
@@ -152,12 +156,24 @@
 m_privmsg(struct Client *client_p,
           struct Client *source_p, int parc, char *parv[])
 {
+  char equiv[NICKLEN + 1];
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  if (strchr(parv[1], ','))
+  	cluster_prefix(client_p, parc, parv, 1, 0, 3);
+  else
+  	cluster_prefix(client_p, parc, parv, 1, IsChannelName(parv[1]), 0);
+
   /* servers have no reason to send privmsgs, yet sometimes there is cause
    * for a notice.. (for example remote kline replies) --fl_
    */
   if (!IsPerson(source_p))
     return;
 
+  if (parc > 1)
+    if (parv[1][0] && get_equiv_nick(parv[1], equiv))
+      parv[1] = equiv;
+
   m_message(PRIVMSG, "PRIVMSG", client_p, source_p, parc, parv);
 }
 
@@ -165,6 +181,18 @@
 m_notice(struct Client *client_p,
          struct Client *source_p, int parc, char *parv[])
 {
+  char equiv[NICKLEN + 1];
+
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  if (strchr(parv[1], ','))
+  	cluster_prefix(client_p, parc, parv, 1, 0, 3);
+  else
+  	cluster_prefix(client_p, parc, parv, 1, IsChannelName(parv[1]), 0);
+
+  if (parc > 1)
+    if (parv[1][0] && get_equiv_nick(parv[1], equiv))
+      parv[1] = equiv;
+
   m_message(NOTICE, "NOTICE", client_p, source_p, parc, parv);
 }
 
@@ -186,7 +214,7 @@
   if (parc < 2 || *parv[1] == '\0')
   {
     if (p_or_n != NOTICE)
-      sendto_one(source_p, form_str(ERR_NORECIPIENT), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_NORECIPIENT), me.name,
                  source_p->name, command);
     return;
   }
@@ -194,7 +222,7 @@
   if (parc < 3 || *parv[2] == '\0')
   {
     if (p_or_n != NOTICE)
-      sendto_one(source_p, form_str(ERR_NOTEXTTOSEND), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_NOTEXTTOSEND), me.name,
                  source_p->name);
     return;
   }
@@ -296,7 +324,7 @@
         {
           if (ntargets >= ConfigFileEntry.max_targets)
 	    {
-	      sendto_one(source_p, form_str(ERR_TOOMANYTARGETS),
+	      sendto_one(source_p, form_str(source_p,ERR_TOOMANYTARGETS),
 			 me.name, source_p->name, nick);
 	      return (1);
 	    }
@@ -309,7 +337,7 @@
         if (!ServerInfo.hub && (uplink != NULL) && IsCapable(uplink, CAP_LL))
           return -1;
         else if (p_or_n != NOTICE)
-          sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name,
+          sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK), me.name,
                      source_p->name, nick);
       }
       continue;
@@ -322,7 +350,7 @@
       {
         if (ntargets >= ConfigFileEntry.max_targets)
 	  {
-	    sendto_one(source_p, form_str(ERR_TOOMANYTARGETS),
+	    sendto_one(source_p, form_str(source_p,ERR_TOOMANYTARGETS),
 		       me.name, source_p->name, nick);
 	    return (1);
 	  }
@@ -356,7 +384,7 @@
       /* suggested by Mortiis */
       if (*nick == '\0')      /* if its a '\0' dump it, there is no recipient */
 	{
-	  sendto_one(source_p, form_str(ERR_NORECIPIENT),
+	  sendto_one(source_p, form_str(source_p,ERR_NORECIPIENT),
 		     me.name, source_p->name, command);
 	  continue;
 	}
@@ -369,7 +397,7 @@
 	{
 	  if(!is_any_op(chptr, source_p) && !is_voiced(chptr, source_p))
 	    {
-	      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+	      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
 			 source_p->name, with_prefix);
 	      return(-1);
 	    }
@@ -378,7 +406,7 @@
 	    {
 	      if (ntargets >= ConfigFileEntry.max_targets)
 		{
-		  sendto_one(source_p, form_str(ERR_TOOMANYTARGETS),
+		  sendto_one(source_p, form_str(source_p,ERR_TOOMANYTARGETS),
 			     me.name, source_p->name, nick);
 		  return (1);
 		}
@@ -392,7 +420,7 @@
 	  if (!ServerInfo.hub && (uplink != NULL) && IsCapable(uplink, CAP_LL))
 	    return -1;
 	  else if (p_or_n != NOTICE)
-	    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name,
+	    sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK), me.name,
 		       source_p->name, nick);
 	}
       continue;
@@ -407,7 +435,7 @@
       if (!ServerInfo.hub && (uplink != NULL) && IsCapable(uplink, CAP_LL))
         return -1;
       else if(p_or_n != NOTICE)
-        sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK),
 	           me.name, source_p->name, nick);
     }
     /* continue; */
@@ -475,16 +503,67 @@
   /* chanops and voiced can flood their own channel with impunity */
   if ((result = can_send(vchan, source_p)))
   {
+    if (result == CAN_SEND_NOTREG)
+	{
+	  if (p_or_n != NOTICE)
+	    sendto_one(source_p, form_str(source_p,ERR_CANNOTSENDNOTREG),
+		       me.name, source_p->name, chname);
+	  return;
+	}
     if (result == CAN_SEND_OPV ||
         !flood_attack_channel(p_or_n, source_p, vchan, chname))
     {
-      sendto_channel_butone(client_p, source_p, vchan, command, ":%s", text);
+		dlink_node *ptr;
+		struct Ban *banptr;
+		char strbuf[BUFSIZE+1], buf[TOPICLEN+1];
+		char *word, *subst, *p = buf;
+		int drop = 0;
+
+		if (MyClient(source_p) && IsPerson(source_p))
+		if (!is_chan_op(vchan, source_p) && NoRepeatChannel(vchan))
+		if (check_repeat(source_p, vchan, text)) {
+			sendto_one(source_p, form_str(source_p,ERR_NOREPEATING),
+				me.name, source_p->name, chname);
+			return;
+		}
+
+	  if (NoColorChannel(vchan)) 
+	    /*strip_color(text);*/
+	    text = strip_color(text, 0);
+
+	  strncpy(strbuf, text, BUFSIZE)[BUFSIZE] = 0;
+
+	  if (MyClient(source_p) && IsPerson(source_p))
+	  if (!is_chan_op(vchan, source_p))
+	  for (ptr = vchan->substlist.head; ptr; ptr = ptr->next, p = buf) {
+		  banptr = ptr->data; 
+		  strncpy(buf, banptr->banstr, TOPICLEN)[TOPICLEN] = 0;
+
+		  while (*p) 
+			  if (*p++ == '$')
+				  *(p-1) = ' ';
+
+		  subst = strchr(buf, '/'); if (subst) {
+			  *subst++ = 0; word = buf;
+			  if (strstr(strbuf, word) && !irccmp(subst, "&"))
+			  	drop = 1;
+			  replace(strbuf, word, subst, BUFSIZE);
+			  strbuf[BUFSIZE] = 0;
+		  }
+	  }
+
+      if (!drop) {
+	  if (PaceChannel(vchan) && (vchan->msgs < MAX_PACEMSG))
+	    add_pace_msg(vchan, client_p, source_p, command, strbuf);
+	  else
+      	sendto_channel_butone(client_p, source_p, vchan, command, ":%s", strbuf);
+      }
     }
   }
   else
   {
     if (p_or_n != NOTICE)
-      sendto_one(source_p, form_str(ERR_CANNOTSENDTOCHAN),
+      sendto_one(source_p, form_str(source_p,ERR_CANNOTSENDTOCHAN),
                  me.name, source_p->name, chname);
   }
 }
@@ -539,6 +618,10 @@
   if (!vchan)
     vchan = chptr;
 
+  if (NoColorChannel(vchan)) 
+    /*strip_color(text);*/
+    text = strip_color(text, 0);
+
   if (MyClient(source_p))
   {
     /* idletime shouldnt be reset by notice --fl */
@@ -595,24 +678,60 @@
      * and its not a notice */
     if ((p_or_n != NOTICE) && (source_p != target_p) && source_p->user)
       source_p->user->last = CurrentTime;
+      
+    if (IsSetSSLaccept(target_p)) {
+#ifdef HAVE_LIBCRYPTO
+  		int fd = source_p->localClient->fd;
+  		fde_t *F = (fd > -1)? &fd_table[fd] : NULL;
+  	
+  		if (F && !F->ssl) {
+#endif
+  			sendto_one(source_p, form_str(source_p,ERR_SSLACCEPTONLY),
+  				me.name, source_p->name, target_p->name);
+  			return;
+  			
+#ifdef HAVE_LIBCRYPTO
+		}
+#endif
+	}
   }
 
   if (MyConnect(source_p) && (p_or_n != NOTICE) &&
       target_p->user && target_p->user->away)
-    sendto_one(source_p, form_str(RPL_AWAY), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_AWAY), me.name,
                source_p->name, target_p->name, target_p->user->away);
 
   if (MyClient(target_p))
   {
+    if (IsSetRegAccept(target_p) && !(source_p->svsflags & FLAGS_SVS_IDENT))
+	{
+	  if (p_or_n != NOTICE)
+	    sendto_one(source_p, form_str(source_p,ERR_REGACCEPTONLY),
+		       me.name, source_p->name, target_p->name);
+	    return;
+	}
+
+	if (ConfigFileEntry.spam_wait && (p_or_n != NOTICE) &&
+	((target_p->localClient->last_join_time + ConfigFileEntry.spam_wait > CurrentTime) ||
+	(target_p->localClient->last_leave_time + ConfigFileEntry.spam_wait > CurrentTime)))
+	{
+		sendto_anywhere(source_p, target_p, 
+			"NOTICE %s :*** I'm joining/leaving a chan, please try again in a few seconds.",
+			source_p->name);
+		return;
+	}
+
     if (!IsServer(source_p) && IsSetCallerId(target_p))
     {
       /* Here is the anti-flood bot/spambot code -db */
-      if (accept_message(source_p, target_p))
+      if (accept_message(source_p, target_p) || (source_p == target_p) ||
+          find_z_conf((char *)source_p->user->server))
       {
         sendto_one(target_p, ":%s!%s@%s %s %s :%s",
                    source_p->name,
                    source_p->username,
-                   source_p->host, command, target_p->name, text);
+                   source_p->host, 
+                   command, target_p->name, translate(target_p, text));
       }
       else
       {
@@ -653,7 +772,7 @@
           (MyClient(source_p) &&
            !flood_attack_client(p_or_n, source_p, target_p)))
         sendto_anywhere(target_p, source_p, "%s %s :%s",
-                        command, target_p->name, text);
+                        command, target_p->name, translate(target_p, text));
     }
   }
   else
@@ -829,7 +948,7 @@
       
     if ((s = strrchr(nick, '.')) == NULL)
     {
-      sendto_one(source_p, form_str(ERR_NOTOPLEVEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOTOPLEVEL),
                  me.name, source_p->name, nick);
       return;
     }
@@ -838,7 +957,7 @@
         break;
     if (*s == '*' || *s == '?')
     {
-      sendto_one(source_p, form_str(ERR_WILDTOPLEVEL),
+      sendto_one(source_p, form_str(source_p,ERR_WILDTOPLEVEL),
                  me.name, source_p->name, nick);
       return;
     }
@@ -909,15 +1028,15 @@
           source_p->user->last = CurrentTime;
       }
       else
-        sendto_one(source_p, form_str(ERR_TOOMANYTARGETS),
+        sendto_one(source_p, form_str(source_p,ERR_TOOMANYTARGETS),
                    me.name, source_p->name, nick);
     }
   }
   else if (server && *(server+1) && (target_p == NULL))
-    sendto_one(source_p, form_str(ERR_NOSUCHSERVER), me.name,
+    sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER), me.name,
                source_p->name, server+1);
   else if (server && (target_p == NULL))
-    sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name,
+    sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK), me.name,
                source_p->name, nick);
 }
 
@@ -939,18 +1058,74 @@
 
   *count = 0;
   if (collapse(user) != NULL)
-    {
-      for (c2ptr = GlobalClientList; c2ptr; c2ptr = c2ptr->next) 
+  {
+    for (c2ptr = GlobalClientList; c2ptr; c2ptr = c2ptr->next) 
 	{
 	  if (!MyClient(c2ptr)) /* implies mine and an user */
 	    continue;
 	  if ((!host || match(host, c2ptr->host)) &&
 	      irccmp(user, c2ptr->username) == 0)
-	    {
-	      (*count)++;
-	      res = c2ptr;
-	    }
+	  {
+	    (*count)++;
+	    res = c2ptr;
+	  }
 	}
-    }
+  }
   return (res);
+}
+
+/*
+ * this will replace all occurances of "word" in "buf" with "subst"
+ *													-demond
+ */
+static void replace(char *buf, char *word, char *subst, int size)
+{
+	char *p = buf;
+	int len1 = strlen(word), len2 = strlen(subst);
+
+	while (*p)
+		if (!ircncmp(p, word, len1)) {
+			if (p + len2 + strlen(p + len1) > buf + size)
+				return;
+			memmove(p + len2, p + len1, strlen(p + len1) + 1);
+			memmove(p, subst, len2);
+			p += len2;
+		}
+		else
+			p++;
+}
+
+/*
+ * check for public repeating and keep/replace appropriate last phrase
+ *													-demond
+ */
+static int check_repeat(struct Client *source_p,
+						struct Channel *chptr,
+						char *text)
+{
+	dlink_node *ptr;
+	struct Repeat *repeatptr;
+
+	for (ptr = source_p->user->repeat.head; ptr; ptr = ptr->next) {
+		repeatptr = ptr->data;
+		if (repeatptr->chptr == chptr)
+			if (!strcmp(repeatptr->text, text)) {
+				return 1;
+			} else {
+				MyFree(repeatptr->text);
+				DupString(repeatptr->text, text);
+				repeatptr->lastphrase = CurrentTime;
+				return 0;
+			}
+	}
+
+	repeatptr = (struct Repeat *)MyMalloc(sizeof(struct Repeat));
+	repeatptr->chptr = chptr;
+	DupString(repeatptr->text, text);
+	repeatptr->lastphrase = CurrentTime;
+
+	ptr = make_dlink_node();
+	dlinkAdd(repeatptr, ptr, &source_p->user->repeat);
+
+	return 0;
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_mode.c ircd-hybrid-7-bg/modules/core/m_mode.c
--- ircd-hybrid-7rc5/modules/core/m_mode.c	Sun Jul 21 12:17:45 2002
+++ ircd-hybrid-7-bg/modules/core/m_mode.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_mode.c,v 1.55 2002/07/21 16:17:45 leeh Exp $
+ *  $Id: m_mode.c,v 1.3 2003/05/24 00:07:46 demond Exp $
  */
 
 #include "stdinc.h"
@@ -41,6 +41,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "packet.h"
+#include "s_misc.h"
 
 static void m_mode(struct Client*, struct Client*, int, char**);
 
@@ -63,7 +64,7 @@
 }
 
 
-const char *_version = "$Revision: 1.55 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * m_mode - MODE command handler
@@ -83,6 +84,16 @@
   struct Channel* vchan;
 #endif
 
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  cluster_prefix(client_p, parc, parv, 1, IsChannelName(parv[1]), 0);
+  if (IsChannelName(parv[1]))
+  	cluster_prefix(client_p, parc, parv, 2, 0, 2);
+
+/*  if (client_p->user)
+	  client_p->user->known = 1;
+
+  this marks drones as known clients... */
+  
   /* Now, try to find the channel in question */
   if (!IsChanPrefix(parv[1][0]))
     {
@@ -93,7 +104,7 @@
 
   if (!check_channel_name(parv[1]))
     { 
-      sendto_one(source_p, form_str(ERR_BADCHANNAME),
+      sendto_one(source_p, form_str(source_p,ERR_BADCHANNAME),
 		 me.name, parv[0], (unsigned char *)parv[1]);
       return;
     }
@@ -133,7 +144,7 @@
 	}
       else
 	{
-	  sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+	  sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
 		     me.name, parv[0], parv[1]);
 	  return;
 	}
@@ -149,13 +160,13 @@
      struct Client *target_p;
      if (!(target_p = find_client(++parv[2])))
        {
-        sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL), me.name,
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL), me.name,
                    parv[0], root->chname);
         return;
        }
      if ((chptr = map_vchan(root, target_p)) == NULL)
        {
-        sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL), me.name,
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL), me.name,
                    parv[0], root->chname);
         return;
        }
@@ -190,7 +201,7 @@
   if (parc < n+1)
     {
       channel_modes(chptr, source_p, modebuf, parabuf);
-      sendto_one(source_p, form_str(RPL_CHANNELMODEIS),
+      sendto_one(source_p, form_str(source_p,RPL_CHANNELMODEIS),
 		 me.name, parv[0], parv[1],
 		 modebuf, parabuf);
       
@@ -198,11 +209,11 @@
        * the top root chan TS
        */
       if (!IsOper(source_p))
-	sendto_one(source_p, form_str(RPL_CREATIONTIME),
+	sendto_one(source_p, form_str(source_p,RPL_CREATIONTIME),
 		   me.name, parv[0],
 		   parv[1], root->channelts);
       else
-	sendto_one(source_p, form_str(RPL_CREATIONTIME),
+	sendto_one(source_p, form_str(source_p,RPL_CREATIONTIME),
 		   me.name, parv[0],
 		   parv[1], chptr->channelts);
     }
